org.optaplanner.core.impl.score.buildin.simplelong

## Class SimpleLongScoreDefinition

- java.lang.Object
- - org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<SimpleLongScore>
  - - org.optaplanner.core.impl.score.buildin.simplelong.SimpleLongScoreDefinition

- All Implemented Interfaces:
    Serializable, ScoreDefinition<SimpleLongScore>

      public class SimpleLongScoreDefinition
      extends AbstractScoreDefinition<SimpleLongScore>

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleLongScoreDefinition()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SimpleLongScore` | `buildOptimisticBound(InitializingScoreTrend initializingScoreTrend, SimpleLongScore score)` Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
    `SimpleLongScore` | `buildPessimisticBound(InitializingScoreTrend initializingScoreTrend, SimpleLongScore score)` Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
    `ScoreHolder` | `buildScoreHolder(boolean constraintMatchEnabled)` Used by `DroolsScoreDirector`.
    `SimpleLongScoreInliner` | `buildScoreInliner(boolean constraintMatchEnabled)` Used by `BavetConstraintFactory`
    `SimpleLongScore` | `divideBySanitizedDivisor(SimpleLongScore dividend, SimpleLongScore divisor)` Return `Score` whose every level is the result of dividing the matching levels in this and the divisor.
    `SimpleLongScore` | `fromLevelNumbers(int initScore, Number[] levelNumbers)` The opposite of `Score.toLevelNumbers()`.
    `int` | `getFeasibleLevelsSize()` Returns the number of levels of `Score.toLevelNumbers()`.
    `SimpleLongScore` | `getOneSoftestScore()` The score that represents the softest possible one.
    `Class<SimpleLongScore>` | `getScoreClass()` Returns the `Class` of the actual `Score` implementation.
    `SimpleLongScore` | `getZeroScore()` The score that represents zero.
    `SimpleLongScore` | `parseScore(String scoreString)` Parses the `String` and returns a `Score`.

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition

      `divide, divide, divide, divide, formatScore, getInitLabel, getLevelLabels, getLevelsSize, isCompatibleArithmeticArgument, sanitize, sanitize, sanitize, sanitize, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition

      `isNegativeOrZero, isPositiveOrZero`

- - ### Constructor Detail

    - #### SimpleLongScoreDefinition

          public SimpleLongScoreDefinition()

  - ### Method Detail

    - #### getFeasibleLevelsSize

          public int getFeasibleLevelsSize()

      Description copied from interface: `ScoreDefinition`
      Returns the number of levels of `Score.toLevelNumbers()`. that are used to determine `Score.isFeasible()`.
      Returns:
        at least 0, at most `ScoreDefinition.getLevelsSize()`

    - #### getScoreClass

          public Class<SimpleLongScore> getScoreClass()

      Description copied from interface: `ScoreDefinition`
      Returns the `Class` of the actual `Score` implementation. For example: returns `HardSoftScore.class` on `HardSoftScoreDefinition`.
      Returns:
        never null

    - #### getZeroScore

          public SimpleLongScore getZeroScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents zero.
      Returns:
        never null

    - #### getOneSoftestScore

          public SimpleLongScore getOneSoftestScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents the softest possible one.
      Returns:
        never null

    - #### parseScore

          public SimpleLongScore parseScore(String scoreString)

      Description copied from interface: `ScoreDefinition`
      Parses the `String` and returns a `Score`.
      Parameters:
        `scoreString` - never null
      Returns:
        never null
      See Also:
        `ScoreDefinition.formatScore(Score)`, `ScoreUtils.parseScore(Class, String)`

    - #### fromLevelNumbers

          public SimpleLongScore fromLevelNumbers(int initScore,
                                                  Number[] levelNumbers)

      Description copied from interface: `ScoreDefinition`
      The opposite of `Score.toLevelNumbers()`.
      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
        `levelNumbers` - never null
      Returns:
        never null

    - #### buildScoreInliner

          public SimpleLongScoreInliner buildScoreInliner(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `BavetConstraintFactory`
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildScoreHolder

          public ScoreHolder buildScoreHolder(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `DroolsScoreDirector`.
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildOptimisticBound

          public SimpleLongScore buildOptimisticBound(InitializingScoreTrend initializingScoreTrend,
                                                      SimpleLongScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`.
      Returns:
        never null

    - #### buildPessimisticBound

          public SimpleLongScore buildPessimisticBound(InitializingScoreTrend initializingScoreTrend,
                                                       SimpleLongScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`
      Returns:
        never null

    - #### divideBySanitizedDivisor

          public SimpleLongScore divideBySanitizedDivisor(SimpleLongScore dividend,
                                                          SimpleLongScore divisor)

      Description copied from interface: `ScoreDefinition`
      Return `Score` whose every level is the result of dividing the matching levels in this and the divisor. When rounding is needed, it is floored (as defined by `Math.floor(double)`).

      If any of the levels in the divisor are equal to zero, the method behaves as if they were equal to one instead.

        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor

Copyright © 2006–2021 JBoss by Red Hat. All rights reserved.